Package: RCSL
Type: Package
Title: Rank Constrained Similarity Learning for single cell RNA
        sequencing data
Version: 1.21.0
Date: 2021-04-01
Authors@R: c(
  person(given = "Qinglin", family = "Mei", email = "meiqinglinkf@163.com", role = c("cre","aut")),
  person(given = "Guojun", family = "Li", email = "guojunsdu@gmail.com", role = "fnd"),
  person(given = "Zhengchang", family = "Su", email = "zcsu@uncc.edu", role = "fnd"))
Maintainer: Qinglin Mei <meiqinglinkf@163.com>
Description: A novel clustering algorithm and toolkit RCSL (Rank Constrained Similarity Learning) to accurately identify various cell types using scRNA-seq data from a complex tissue. RCSL considers both lo-cal similarity and global similarity among the cells to discern the subtle differences among cells of the same type as well as larger differences among cells of different types. RCSL uses Spearman’s rank correlations of a cell’s expression vector with those of other cells to measure its global similar-ity, and adaptively learns neighbour representation of a cell as its local similarity. The overall similar-ity of a cell to other cells is a linear combination of its global similarity and local similarity. 
URL: https://github.com/QinglinMei/RCSL
Depends: R (>= 4.1)
License: Artistic-2.0
VignetteBuilder: knitr
biocViews: SingleCell, Software, Clustering, DimensionReduction,
        RNASeq, Visualization, Sequencing
Suggests: testthat, knitr, BiocStyle, rmarkdown, mclust, tidyverse,
        tinytex
Imports: RcppAnnoy, igraph, NbClust, Rtsne, ggplot2(>= 3.4.0), methods,
        pracma, umap, grDevices, graphics, stats, Rcpp (>= 0.11.0),
        MatrixGenerics, SingleCellExperiment
LazyData: TRUE
Encoding: UTF-8
RoxygenNote: 7.3.1
NeedsCompilation: no
Packaged: 2026-04-29 00:35:32 UTC; biocbuild
Author: Qinglin Mei [cre, aut],
  Guojun Li [fnd],
  Zhengchang Su [fnd]
git_url: https://git.bioconductor.org/packages/RCSL
git_branch: devel
git_last_commit: daa9941
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28

# Rank Constrained Similarity Learning (RCSL)
RCSL is an R toolkit for single-cell clustering and trajectory analysis using single-cell RNA-seq data.

## Installation
This package can be insatlled through devtools in R:
```{r}
$ R
> library("devtools")
> devtools::install_github("QinglinMei/RCSL",build_vignettes = T)
```
Now RCSL can be loaded in R:
```{r}
> library(RCSL)
```
## Input

The input to RCSL is a normalized data matrix with columns being cells and rows being genes in log(CPM+1), log(RPKM+1), log(TPM+1) or log(FPKM+1) format; or a data file in RDS format.

## Usage

We provide an example script to run RCSL in *demo_RCSL.R*. 

The nine functions of RCSL can also be run independently.

Function | Description
-----------|----------
`GenesFilter` | Perform genes filtering.
`SimS` | Calculate the initial similarity matrix S.
`NeigRepresent` | Calculate the neighbor representation of cells.
`EstClusters` | Estimate the optimal number of clusters C.
`BDSM` | Learn the block-diognal matrix B.
`PlotMST` | Construct MST based on clustering results from RCSL.
`PlotPseudoTime` | Infer the pseudo-temporal ordering of cells.
`getLineage` | Infer the lineage based on the clustering results and the starting cell.
`PlotTrajectory` | Plot the developmental trajectory based on the clustering results and the starting cell.

## Example:

Load packages:
```{r}
> library(RCSL)
> library(SingleCellExperiment)
> library(ggplot2)
> library(igraph)
```
Load Goolam dataset:
```{r}
> origData <- readRDS("./Data/Goolam.rds")
> data <- logcounts(origData)
> label <- origData$cell_type1
> DataName <- "Goolam"
```
Generating clustering result:
```{r}
> res_RCSL <- RCSL(data)
```
Calculating Adjusted Rand Index:
```{r}
> ARI_RCSL <- igraph::compare(res_RCSL$y, label, method = "adjusted.rand")
```
Trajectory analysis:
```{r}
> label <- origData$cell_type1
> res_TrajecAnalysis <- TrajectoryAnalysis(res_RCSL$gfData, res_RCSL$drData, res_RCSL$S,
                                         clustRes = res_RCSL$y, TrueLabel = label, startPoint = 1,
                                         dataName = DataName)
```
Display the plot of constructed MST: 
```{r}
> res_TrajecAnalysis$MSTPlot
```
Display the plot of the pseudo-temporal ordering 
```{r}
> res_TrajecAnalysis$PseudoTimePlot
```
Display the plot of the inferred developmental trajectory
```{r}
> res_TrajecAnalysis$TrajectoryPlot
```
A vignette in R Notebook format is available [here](https://github.com/QinglinMei/RCSL/blob/master/vignettes/RCSL-vignette.Rmd)

## Required annotations for RCSL

1) The RCSL package requires three extra packages: namely the *SingleCellExperiment* package (see https://bioconductor.org/packages/release/bioc/html/SingleCellExperiment.html) to read the *SingleCellExperiment* object, the *igraph* package (see https://igraph.org/) to find the stronggest connected components and the *ggplot2* package (see https://cran.r-project.org/web/packages/ggplot2/index.html) to plot the developmental trajectory and MST.
2) The dataset for the demonstration purpose in the directory *Data* was from https://hemberg-lab.github.io/scRNA.seq.datasets/. This dataset is stored in both RDS and text formats.


## DEBUG

Please feel free to contact us if you have problems running our tool at meiql@mail.sdu.edu.cn.

#'
#' Perform the RCSL program
#'
#' @param data normalizaed gene expression matrix(each column represents a cell)
#' @param GF should I need the gene filter step?
#' @param gfRatio the ratio of the gene filter
#' @param pcRatio the ratio between the variance of the choosed PCs and the total variance
#' @param pcRatio the ratio between the variance of the 
#’                 choosed PCs and the total variance
#' @param NN.method the method of finding neighbors
#' @param Dis.method the distance metric in finding neighbors                    
#' @param neiRatio ratio of the number of selected 
#‘                 neighbors to the total number of cells 
#' @return gfData gene expression matrix after genes filtering
#' @return B block-diagonal matrix
#' @return C estimated number of clusters
#' @return y clustering results
#'
#' @export
#'
#' @examples 
#' data(yan)
#' data <- log2(yan+1)
#' RCSL(yan[,1:20])

RCSL <- function(data, GF = TRUE, gfRatio = 0.025, pcRatio = 0.95,
                 NN.method = "KNN", Dis.method = "Euclidean", neiRatio = 0.65){

# Gene filter
if(GF == TRUE){
gfData <- GenesFilter(data, gfRatio)
} else{
gfData <- data[rowSums(data)!=0,,drop=FALSE]
}

# Calculate the similarity matrix S
resSimS <- SimS(gfData, pcRatio, NN.method = "KNN", Dis.method = "Euclidean")

# Estimate the number of clusters C
Estimated_C <- EstClusters(resSimS$drData,resSimS$S)

# Calculate the block diagonal matrix B
res_BDSM <- BDSM(resSimS$S, Estimated_C)

B <- res_BDSM$B
y <- res_BDSM$y

res <- list("gfData" = gfData, "drData" = resSimS$drData,
            "S" = resSimS$S, "B" = B, "C" = Estimated_C, "y" = y)
return(res)
}

#'
#' Plot the visualization of constructed Minimum Spanning Tree based on the clustering results of RCSL
#'
#' @param drData preprocessed gene expression data 
#‘               (each column represent a cell)
#' @param clustRes the clustering results identified by RCSL
#' @param TrueLabel the real cell types to color the dots in plot
#' @param dataName the name of the data that will be showed in the plot
#' @param fontSize the font size of the plot
#' @param VisualMethod the method for 2D visualization including UMAP,t-SNE and PCA
#'
#' @return MSTPlot ggplot object of the visualization of constructed MST
#'
#' @export
#'
#' @examples
#' gfData <- GenesFilter(yan)
#' TrueLabel <- ann$cell_type1
#' res_SimS <- SimS(gfData)
#' C <- EstClusters(res_SimS$drData,res_SimS$S)
#' res_BDSM <- BDSM(res_SimS$S,C)
#' PlotMST(res_SimS$drData,res_BDSM$y,TrueLabel)
#'
"PlotMST" <- function(drData, clustRes, TrueLabel, dataName = "",
                    fontSize = 12, VisualMethod = "umap"){

  centers_num <- max(clustRes)
  centers <- matrix(nrow=nrow(drData),ncol = centers_num)

  for(i in seq_len(centers_num)){
      centers[,i] <- rowMeans(drData[,which(clustRes == i),drop = FALSE])
  }

  centersSim <- (stats::cor(centers, method = "kendall") + 1) / 2
  g <- igraph::graph_from_adjacency_matrix(centersSim,mode = "undirected",weighted = TRUE,diag = FALSE)
  g_mst <- igraph::mst(g)

  if(VisualMethod == "umap"){
     reducedData <- data.frame(umap::umap(t(drData),n_components = 2)$layout)
     x.lab = "umap1"
     y.lab = "umap2"
  }
  if(VisualMethod == "tsne"){
     reducedData <- data.frame(Rtsne::Rtsne(t(drData),perplexity = 10)$Y)
     x.lab = "tsne1"
     y.lab = "tsne2"
  }
  if(VisualMethod == "pca"){
     res_PCA <- stats::prcomp(t(drData),center = TRUE, scale. = TRUE)$x
     reducedData <- data.frame(res_PCA[,seq_len(2)])
     colnames(reducedData) <- c("X1","X2")
     x.lab = "pca1"
     y.lab = "pca2"
  }
  reducedData.centers <- matrix(nrow = max(clustRes),ncol = 2)
  for(i in seq_len(max(clustRes))){
     reducedData.centers[i,] = colMeans(reducedData[which(clustRes == i),])
  }
  gg <- igraph::get.data.frame(g_mst)
  df_centers <- as.data.frame(reducedData.centers)
  df_centers$vertices <- c(seq_len(nrow(reducedData.centers)))
  gg$from.x <- df_centers$V1[match(gg$from, df_centers$vertices)]
  gg$from.y <- df_centers$V2[match(gg$from, df_centers$vertices)]
  gg$to.x <- df_centers$V1[match(gg$to, df_centers$vertices)]
  gg$to.y <- df_centers$V2[match(gg$to, df_centers$vertices)]
  reducedData$label <- TrueLabel
  colorFeature <- c("#f54291","#1089ff","#f3c623","#7e0cf5","#fb832d","#32ff6a",
                    "#B07AA1","#B65412","#FF6666","#7c3c21","#ff427f","#56C188")
  MSTPlot <- ggplot2::ggplot() + geom_point(data = reducedData, aes(x = X1, y = X2, color = label),size = 1.3,alpha = 0.75) +
    scale_colour_manual(values = colorFeature) +
    geom_segment(data = gg,aes(x = from.x, xend = to.x, y = from.y, yend = to.y),
                 size = 1.2,colour = "black") +
    geom_point(data = df_centers,aes(x = V1, y = V2),size = 2.3,alpha = 0.8,colour = "black") +
    ggtitle(dataName) + labs(x = x.lab, y = y.lab) +
    theme(panel.background = element_blank(),
          legend.text = element_text(size = (fontSize - 2)),
          axis.title = element_text(size = fontSize),
          axis.text = element_blank(),
          axis.line = element_line(colour = "black"),
          legend.position="right",legend.title = element_blank(),
          plot.title = element_text(size = fontSize, face = "bold", hjust = 0.5),
          legend.key = element_blank(), legend.background = element_blank(),
          legend.box.margin=margin(-15,0,0,-9),
          legend.justification = "top",
          legend.key.width = unit(0, "lines"),
          legend.key.size = unit(1,"lines"),
          plot.margin = unit(c(0.5, 1.5, 1.5, 0.5), "lines"))+
          guides(colour = guide_legend(direction = "vertical"))

  return(MSTPlot)
}

#'
#' Infer the pseudo-temporal ordering between the cell types using the
#' distance from a cell type to the predefined starting cell type.
#'
#' @param S the similarity matrix calculated by SimS() function
#' @param TrueLabel the real cell types used to indicate the vertical axis
#' @param startPoint the posiition of the starting cell in the matrix
#' @param fontSize the font size of the plot
#' @param dataName the name of the data that will be showed in the plot
#' @param sim indicate the input data is simialrity matrix or not
#'
#' @return PstudoTime
#' @return PseudoTimePlot  ggplot object of the pseudo-temporal ordering of cells
#'
#' @export
#'
#' @examples
#' gfData <- GenesFilter(yan)
#' TrueLabel <- ann$cell_type1
#' res_SimS <- SimS(gfData)
#' PlotPseudoTime(res_SimS$S,TrueLabel,startPoint=1)
#'
"PlotPseudoTime" <- function(S, TrueLabel, startPoint, fontSize = 12,
                             dataName = "", sim = TRUE){

  if(sim == TRUE){
     NormA <- S / sum(S)
     Dist <- (1 - NormA)
  } else{
     Dist = as.matrix(stats::dist(S))
  }

  startPoint <- startPoint+1

  pseudoTime <- Dist[startPoint,]

  gInput <- data.frame( x = pseudoTime[-1],
                        y = TrueLabel[-1],
                        Timepoint = TrueLabel[-1])

  colorFeature <- c("#f54291","#1089ff","#f3c623","#7e0cf5","#fb832d","#32ff6a",
                    "#B07AA1","#B65412","#FF6666","#7c3c21","#ff427f","#56C188")

  PseudoTimePlot <- ggplot2::ggplot(gInput, aes(x = x, y = y, colour = Timepoint)) +
       geom_point(size = 1.1,alpha = 0.78) + labs(x = "Pseudo Time") +
       scale_colour_manual(values = colorFeature) +
       ggtitle(dataName)+
       theme( panel.background = element_blank(), panel.border = element_blank(),
              panel.grid.minor = element_blank(), panel.grid.major = element_blank(),
              axis.line = element_line(colour = "black"),
              axis.text.x = element_blank(),
              axis.text.y = element_text(size = fontSize,colour = "black"),
              axis.title.y = element_blank(),
              axis.title.x = element_text(size = fontSize),
              plot.title = element_text(size = fontSize, face = "bold", hjust = 0.5),
              legend.text = element_text(size = (fontSize)),
              legend.position = "none",legend.title = element_blank(),legend.box = "vertical",
              legend.key = element_blank(),
              legend.spacing.x = unit(0, 'cm'))

  res <- list("PstudoTime" = pseudoTime, "PseudoTimePlot" = PseudoTimePlot )

  return(res)
}

#'
#' Infer the development lineage based on the clustering results from RCSL and the pseudotime
#'
#' @param drData preprocessed gene expression data (each column represent a cell)
#' @param clustRes the clustering results identified by RCSL
#' @param pseudoTime inferred by PlotPseudoTime() using the similarity matrix S and starting cell
#' @param simMeasure the calculation method of measuring the cluster centers' similarity
#'
#' @return lineage the cell lineages connected all the cluster centers based on the clustering results from RCSL
#'
#' @export
#'
#' @examples
#' gfData <- GenesFilter(yan)
#' TrueLabel <- ann$cell_type1
#' res_SimS <- SimS(gfData)
#' C <- EstClusters(res_SimS$drData,res_SimS$S)
#' res_BDSM <- BDSM(res_SimS$S,C)
#' Pseudo <- PlotPseudoTime(res_SimS$S,TrueLabel,startPoint=1)
#' getLineage(res_SimS$drData,res_BDSM$y,Pseudo$pseudoTime)
#'

"getLineage" <- function(drData, clustRes, pseudoTime, simMeasure = "kendall"){
  centers_num <- max(clustRes)
  centers <- matrix(nrow = nrow(drData),ncol = centers_num)
  centersPseudo <- numeric(length(centers_num))
  for(i in seq_len(centers_num)){
     centers[,i] <- rowMeans(drData[,which(clustRes == i),drop = FALSE])
     centersPseudo[i] <- mean(pseudoTime[which(clustRes == i)])
  }

  if(simMeasure == "spearman"){
     centersSim <- (stats::cor(centers, method = "spearman") + 1) / 2
  }

  if(simMeasure == "pearson"){
     centersSim <- (stats::cor(centers, method = "pearson") + 1) / 2
  }

  if(simMeasure == "kendall"){
     centersSim <- (stats::cor(centers, method = "kendall") + 1) / 2
  }

  for(j in seq_len(max(clustRes))){
     centersPseudo[j] <- mean(pseudoTime[which(clustRes == j),drop = FALSE])
  }
  g <- igraph::graph_from_adjacency_matrix(centersSim,mode = "undirected",weighted = TRUE,diag = FALSE)
  g_mst <- igraph::mst(g)
  lineage <- numeric()
  Edges <- igraph::get.edgelist(g_mst)
  lineagePre <- table(Edges)
  LineageNum <- max(lineagePre) - 1

  if(LineageNum == 1){
     lineage[c(1,centers_num)] <- which(lineagePre == 1)
     AdjacentNodes = as.list(igraph::adjacent_vertices(g_mst,v = c(seq_len(centers_num))))
     for(i in seq_len(centers_num - 2)){
         AdjNodes = as.numeric(AdjacentNodes[[lineage[i]]])
         lineage[i + 1] = AdjNodes[which(!(AdjNodes %in% lineage))]
     }
  }else{
     vertices <- c(1:centers_num)
     longestPath <- as.numeric(get_diameter(g_mst))
     vers <- vertices[which(!vertices %in% longestPath)]
     EdgesRest <- matrix(nrow = length(vers), ncol = 2)
     for(x in seq_len(length(vers))){
         EdgesRest[x,] <- Edges[which(Edges == vers[x], arr.ind = TRUE)[1],]
      }
     nei <- EdgesRest[EdgesRest != vers]
     for(i in seq_len(length(nei))){
         neis <- longestPath[c(which(longestPath == nei[i]) - 1,which(longestPath == nei[i]) + 1)]
         nearest <- neis[which.max(centersSim[neis, vers[i]])]
         if(which(longestPath == nei[i]) < which(longestPath == nearest)){
             lineage <- append(longestPath, vers, after = which(longestPath == nei[i]))
         }else{
             lineage <- append(longestPath, vers, after = (which(longestPath == nei[i]) - 1))
         }
     }
    lineage = rank(centersPseudo[lineage])
  }

  return(lineage)
}

#'
#' Infer the developmental trajectories based on the clustering results from RCSL
#'
#' @param gfData preprocessed gene expression data (each column represent a cell)
#' @param clustRes the clustering results identified by RCSL
#' @param TrueLabel the real cell types
#' @param lineage  the lineage obtained by getLineage()
#' @param fontSize the size of font in the plot
#' @param dataName the name of the data that will be showed in the plot
#' @param VisualMethod the display method of 2-D visualization
#'
#' @return TrajectoryPlot ggplot object of the inferred developmental trajectories
#'
#' @export
#'
#' @examples
#' gfData <- GenesFilter(yan)
#' TrueLabel <- ann$cell_type1
#' res_SimS <- SimS(gfData)
#' C <- EstClusters(res_SimS$drData,res_SimS$S)
#' res_BDSM <- BDSM(res_SimS$S,C)
#' Pseudo <- PlotPseudoTime(res_SimS$S,TrueLabel,startPoint=1)
#' Linea <- getLineage(res_SimS$drData,res_BDSM$y,Pseudo$pseudoTime)
#' PlotTrajectory(gfData,res_BDSM$y,TrueLabel,lineage=Linea)
#'

"PlotTrajectory" <- function(gfData, clustRes, TrueLabel, lineage,
                             fontSize = 12, dataName = "", VisualMethod = "umap"){
  if(VisualMethod == "umap"){
     reducedData <- data.frame(umap::umap(t(gfData),n_components = 2)$layout)
     x.lab = "Umap1"
     y.lab = "Umap2"
  }

  if(VisualMethod == "tsne"){
     reducedData <- data.frame(Rtsne::Rtsne(t(gfData),perplexity = 10)$Y)
     x.lab = "tsne1"
     y.lab = "tsne2"
  }

  if(VisualMethod == "pca"){
     res_PCA <- stats::prcomp(t(gfData),center = TRUE, scale. = TRUE)$x
     reducedData <- data.frame(res_PCA[,seq_len(2)])
     colnames(reducedData) <- c("X1","X2")
     x.lab = "Pca1"
     y.lab = "Pca2"
  }

  reducedDataCenters <- matrix(nrow = max(clustRes), ncol = 2)
  for(i in seq_len(max(clustRes))){
     reducedDataCenters[i,] = colMeans(reducedData[which(clustRes == i),])
  }

  reducedData$label <- TrueLabel
  reducedDataCenters <- as.data.frame(reducedDataCenters[lineage,,drop = FALSE])
  plot(0)
  ps <- data.frame(xspline(reducedDataCenters, shape = -0.2, lwd = 2, draw = FALSE))
  dev.off()

  colorFeature <- c("#f54291","#1089ff","#f3c623","#7e0cf5","#fb832d","#32ff6a",
                    "#B07AA1","#B65412","#FF6666","#7c3c21","#ff427f","#56C188")

  TrajectoryPlot <- ggplot2::ggplot() + geom_point(data = reducedData, aes(x = X1, y = X2, color = label),size = 1.1,alpha = 0.75) +
       scale_colour_manual(values = colorFeature) +
       geom_path(data = ps, aes(x, y),  colour = "black",size = 1.3,
                 arrow = arrow(length = unit(0.3, "cm"), angle = 30, type = "closed"),
                 lineend = "round",linejoin = "round") +
       geom_smooth()+
       ggtitle(dataName)+
       guides(color = guide_legend(nrow = 1)) +
       labs(x = x.lab, y = y.lab) +
       theme(axis.text = element_blank(),
             panel.background = element_blank(), panel.border = element_blank(),
             panel.grid.minor = element_blank(), panel.grid.major = element_blank(),
             axis.line = element_line(colour = "black"),
             axis.title = element_text(size = fontSize),
             plot.title = element_text(size = fontSize, face = "bold", hjust = 0.5),
             legend.position = "right",legend.title = element_blank(),
             legend.text = element_text(size = (fontSize - 2)),
             legend.key = element_blank(), legend.background = element_blank(),
             legend.box.margin=margin(-15,0,0,-9),
             legend.justification = "top",
             legend.key.width = unit(0, "lines"),
             legend.key.size = unit(1,"lines"))+
			 guides(colour = guide_legend(direction = "vertical"))
  return(TrajectoryPlot)
}

#'
#' Trajectory analysis 
#'
#' @param gfData preprocessed gene expression data (each column represent a cell)
#' @param drData preprocessed gene expression data (each column represent a cell)
#' @param S the similarity matrix calculated by SimS() function
#' @param clustRes the clustering results identified by RCSL
#' @param fontSize the size of font in the plot
#' @param TrueLabel the real cell types used to indicate the vertical axis
#' @param startPoint the posiition of the starting cell in the matrix
#' @param dataName the name of the data that will be showed in the plot
#' @param sim indicate the input data is simialrity matrix or not
#' @param simMeasure the calculation method of measuring the cluster centers' similarity
#' @param VisualMethod the display method of 2-D visualization
#'
#' @return PseudoTimePlot, MSTPlot, TrajectoryPlot
#'
#' @export
#'
#' @examples
#' gfData <- GenesFilter(yan)
#' TrueLabel <- ann$cell_type1
#' res_SimS <- SimS(gfData)
#' C <- EstClusters(res_SimS$drData,res_SimS$S)
#' res_BDSM <- BDSM(res_SimS$S,C)
#' TrajectoryAnalysis(gfData,res_SimS$drData,res_SimS$S,res_BDSM$y,
#'                    TrueLabel=TrueLabel,startPoint=1)
#'
"TrajectoryAnalysis" <- function(gfData, drData, S, clustRes, fontSize = 12, TrueLabel,
                                 startPoint, dataName = "", sim = TRUE,
                                 simMeasure = "kendall", VisualMethod = "umap"){

  PseudoRes <- PlotPseudoTime(S, TrueLabel, startPoint, fontSize, dataName)

  lineage <- getLineage(drData, clustRes, PseudoRes$PstudoTime, simMeasure = "kendall")

  PseudoTimePlot <- PseudoRes$PseudoTimePlot

  MSTPlot <- PlotMST(drData, clustRes, TrueLabel, dataName, fontSize, VisualMethod)

  TrajectoryPlot <- PlotTrajectory(gfData, clustRes, TrueLabel, lineage, fontSize,
                                    dataName, VisualMethod)
  res <- list("PseudoTimePlot" = PseudoTimePlot,
              "MSTPlot" = MSTPlot,
              "TrajectoryPlot" = TrajectoryPlot)

  return(res)
}

# ## Construct simulated datasets 

# library(splatter)
# library(scater)

# ## ============= 300 cells 1 =============
# NCells <- 300
# set.seed(1)
# sce <- mockSCE(ncells = NCells, ngenes = 10000)
# params <- splatEstimate(sce)
# sim.groups <- splatSimulate(params, group.prob=c(0.2,0.25,0.25,0.3), method = "groups",
#                             verbose = FALSE)
# sim.groups <- logNormCounts(sim.groups)
# data <- logcounts(sim.groups)
# label <-  sim.groups$Group

# ## ============= 300 cells 2 =============
# NCells <- 300
# set.seed(1)
# sce <- mockSCE(ncells = NCells, ngenes = 15000)
# params <- splatEstimate(sce)
# sim.groups <- splatSimulate(params, group.prob=c(0.2,0.25,0.2,0.2,0.15), method = "groups",
#                             verbose = FALSE)
# sim.groups <- logNormCounts(sim.groups)
# data <- logcounts(sim.groups)
# label <-  sim.groups$Group

# ## ============= 500 cells 1 =============
# NCells <- 500
# DataName <- paste0('SimulateData','_',NCells)
# set.seed(1)
# sce <- mockSCE(ncells = NCells, ngenes = 10000)
# params <- splatEstimate(sce)
# sim.groups <- splatSimulate(params, group.prob=c(0.2,0.2,0.3,0.3), method = "groups",
#                             verbose = FALSE)
# sim.groups <- logNormCounts(sim.groups)
# curData <- logcounts(sim.groups)
# label <-  sim.groups$Group

# ## ============= 500 cells 2 =============
# NCells <- 500
# DataName <- paste0('SimulateData','_',NCells)
# set.seed(1)
# sce <- mockSCE(ncells = NCells, ngenes = 15000)
# params <- splatEstimate(sce)
# sim.groups <- splatSimulate(params, group.prob=c(0.2,0.3,0.2,0.2,0.1), method = "groups",
#                             verbose = FALSE)
# sim.groups <- logNormCounts(sim.groups)
# curData <- logcounts(sim.groups)
# label <-  sim.groups$Group

# ## ============= 1000 cells 1 =============
# NCells <- 1000
# DataName <- paste0('SimulateData','_',NCells)
# set.seed(1)
# sce <- mockSCE(ncells = NCells, ngenes = 10000)
# params <- splatEstimate(sce)
# sim.groups <- splatSimulate(params, group.prob=c(0.2,0.2,0.3,0.2,0.1), method = "groups",
#                             verbose = FALSE)
# sim.groups <- logNormCounts(sim.groups)
# curData <- logcounts(sim.groups)
# label <-  sim.groups$Group

# ## ============= 1000 cells 2 =============
# NCells <- 1000
# DataName <- paste0('SimulateData','_',NCells)
# set.seed(1)
# sce <- mockSCE(ncells = NCells, ngenes = 15000)
# params <- splatEstimate(sce)
# sim.groups <- splatSimulate(params, group.prob=c(0.15,0.1,0.25,0.2,0.1,0.2), method = "groups",
#                             verbose = FALSE)
# sim.groups <- logNormCounts(sim.groups)
# curData <- logcounts(sim.groups)
# label <-  sim.groups$Group

# ## ============= 2000 cells 1 =============
# NCells <- 2000
# DataName <- paste0('SimulateData','_',NCells)
# set.seed(1)
# sce <- mockSCE(ncells = NCells, ngenes = 10000)
# params <- splatEstimate(sce)
# sim.groups <- splatSimulate(params, group.prob=c(0.2,0.2,0.3,0.2,0.1), method = "groups",
#                             verbose = FALSE)
# sim.groups <- logNormCounts(sim.groups)
# curData <- logcounts(sim.groups)
# label <-  sim.groups$Group

# ## ============= 2000 cells 2 =============
# NCells <- 2000
# DataName <- paste0('SimulateData','_',NCells)
# set.seed(1)
# sce <- mockSCE(ncells = NCells, ngenes = 15000)
# params <- splatEstimate(sce)
# sim.groups <- splatSimulate(params, group.prob=c(0.2,0.1,0.2,0.2,0.1,0.2), method = "groups",
#                             verbose = FALSE)
# sim.groups <- logNormCounts(sim.groups)
# curData <- logcounts(sim.groups)
# label <-  sim.groups$Group

# ## ============= 3000 cells 1 =============
# NCells <- 3000
# DataName <- paste0('SimulateData','_',NCells)
# set.seed(1)
# sce <- mockSCE(ncells = NCells, ngenes = 10000)
# params <- splatEstimate(sce)
# sim.groups <- splatSimulate(params, group.prob=c(0.2,0.2,0.15,0.2,0.1,0.15), method = "groups",
#                             verbose = FALSE)
# sim.groups <- logNormCounts(sim.groups)
# curData <- logcounts(sim.groups)
# label <-  sim.groups$Group

# ## ============= 3000 cells 2 =============
# NCells <- 3000
# DataName <- paste0('SimulateData','_',NCells)
# set.seed(1)
# sce <- mockSCE(ncells = NCells, ngenes = 15000)
# params <- splatEstimate(sce)
# sim.groups <- splatSimulate(params, group.prob=c(0.15,0.1,0.25,0.15,0.1,0.15,0.1), method = "groups",
#                             verbose = FALSE)
# sim.groups <- logNormCounts(sim.groups)
# curData <- logcounts(sim.groups)
# label <-  sim.groups$Group

#'
#' Perform the step of gene filtering to normalizaed gene expression data
#'
#' @param data the normalized gene expression matrix 
#’        (each column represents a cell)
#' @param gfRatio the ratio of genes filtering
#'
#' @return the gene expression matrix after genes filtering gfData
#'
#' @export
#'
#' @examples
#' data(yan)
#' GenesFilter(yan)
#'
"GenesFilter" <- function(data, gfRatio = 0.025){

  N <- ncol(data)
  G <- nrow(data)
  ExpressNumMin <- gfRatio * N
  ExpressNumMax <- (1 - gfRatio) * N
  GenesExpress0 <- sapply(seq_len(G), function(n) length(which(data[n,] != 0)))
  gfData <- data[which(GenesExpress0 > ExpressNumMin),,drop = FALSE]
  GenesExpress <- GenesExpress0[which(GenesExpress0 > ExpressNumMin)]
  
  if(max(GenesExpress) == N){
   GenesPre <- gfData[which(GenesExpress > ExpressNumMax),,drop = FALSE]
   GenesVar <- as.matrix(apply(GenesPre, 1, var))
   if(any(GenesVar < 0.9 * mean(GenesVar))){
   gfData <- gfData[-which(GenesVar < 0.9 * mean(GenesVar)),,drop = FALSE]
   }
   
  }
 return(gfData)
}


#'
#' Calculate the initial similarity matrix
#'
#' @param data gene expression matrix after genes filtering 
#‘             (each column represents a cell)
#' @param pcRatio the ratio between the variance of the 
#’                 choosed PCs and the total variance
#' @param gamma the ratio of the global simialrity
#' @param NN.method the method of finding neighbors
#' @param Dis.method the distance metric in finding neighbors
#' @param LSH.TreeNum the tree number of LSH
#' @param LSH.Dim the dimension in LSH
#' @param LSH.Dis the distance metric in LSH                      
#' @param neiRatio ratio of the number of selected 
#‘                 neighbors to the total number of cells                          
#' @return initial similarity matrix S
#' @return gene expression matrix after PCA processing drData
#'
#' @export
#'
#' @examples
#' gfData <- GenesFilter(yan)
#' SimS(gfData)
#'
"SimS" <- function(data, pcRatio = 0.95, gamma = 0.8, NN.method = "KNN", 
                   Dis.method = "Euclidean", LSH.TreeNum = 30, LSH.Dim = 1000, 
                   LSH.Dis = "angular", neiRatio = 0.65){

  res_PCA <- stats::prcomp(t(data), center = TRUE, scale. = TRUE)
  
  if(ncol(data) > 1300){
    EigenValues <- res_PCA$sdev
    V <- sapply(seq_len(length(EigenValues)), 
                function(n) sum(EigenValues[seq_len(n)])/sum(EigenValues))
    n_dim <- min(which(V >= pcRatio))
    res_pca <- t(res_PCA$x[, seq_len(n_dim), drop = FALSE])
    if(n_dim>4000){
    res_pca <- t(res_PCA$x[, seq_len(4000), drop = FALSE])
    }
  }else{
    res_pca <- t(res_PCA$x) 
  }
  
  if(gamma!=1){      
       cat('Calculate the Spearman correlation','\n')
       SpearA <- stats::cor(data, method = "spearman")
       cat('Calculate the Nerighbor Representation','\n')
       NR <- NeigRepresent(res_pca,NN.method = "KNN", Dis.method = "Euclidean",
                        LSH.TreeNum = LSH.TreeNum, LSH.Dim = LSH.Dim, LSH.Dis = LSH.Dis, 
                        neiRatio = neiRatio)
       S <-  gamma * SpearA + (1-gamma) * NR
  } else{
    cat('Calculate the Spearman correlation','\n')
    S <- stats::cor(data, method = "spearman")
  }

  res = list("S" = S, "drData" = res_pca)
  return(res)
}

#'
#' Calculate the neighbor representation of cells to the low-dimensional 
#' gene expression matrix
#' 
#' @import RcppAnnoy
#'
#' @param drData gene expression matrix after dimensionality reduced by PCA
#' @param NN.method the method of finding neighbors
#' @param Dis.method the distance metric in finding neighbors
#' @param LSH.TreeNum the tree number of LSH
#' @param LSH.Dim the dimension in LSH
#' @param LSH.Dis the distance metric in LSH                      
#' @param neiRatio ratio of the number of selected 
#‘                 neighbors to the total number of cells    
#' @return the similarity matrix measured by neighbor representation NR
#'
#' @export
#'
#' @examples 
#' gfData <- GenesFilter(yan)
#' res_SimS <- SimS(gfData)
#' NeigRepresent(res_SimS$drData)
#'
"NeigRepresent" <- function(drData, NN.method = "KNN", Dis.method = "Euclidean", 
                            LSH.TreeNum = 30, LSH.Dim = 500, LSH.Dis = "angular", 
                            neiRatio = 0.65){

k <- ceiling(ncol(drData) * neiRatio)

if(NN.method == "KNN"){
  if(Dis.method == "Euclidean"){
      cat("Find neighbors by KNN(Euclidean)","\n")
      #distMatrix <- as.matrix(stats::dist(t(drData), diag = T, upper = T))
      distMatrix <- EucDist(drData,drData)
  } 
  if(Dis.method == "Cosine"){
      cat("Find neighbors by KNN(Cosine)","\n")
      Cosine_sim <- t(drData) / sqrt(rowSums(t(drData) * t(drData)))
      Cosine_sim <- Cosine_sim %*% t(Cosine_sim)
      distMatrix <- as.matrix(1 - Cosine_sim)
  }
  neigData <- sapply(seq_len(nrow(distMatrix)), function(n){
                     curRow <- sort(distMatrix[n,,drop = TRUE])
                     rownames(as.matrix(which(rank(curRow, ties.method = "first") <= k)))})
}

if(NN.method == "LSH"){
  if(nrow(drData)>LSH.Dim){
    drData <- drData[seq_len(LSH.Dim),,drop = FALSE]
  }
  f = ncol(drData)
  if(LSH.Dis == "angular"){  
      cat("Find neighbors by LSH(Cosine)","\n")
      Tree = methods::new(RcppAnnoy::AnnoyAngular,f)  
  }
  if(LSH.Dis == "hamming"){ 
      cat("Find neighbors by LSH(Hamming)","\n") 
      Tree = methods::new(RcppAnnoy::AnnoyHamming,f)  
  }
  if(LSH.Dis == "Euclidean"){ 
      cat("Find neighbors by LSH(Euclidean)","\n") 
      Tree = methods::new(RcppAnnoy::AnnoyEuclidean,f)  
  }
  for(i in seq(ncol(drData))){
      v = as.vector(drData[,i])
      Tree$addItem(i, v)
  }
  Tree$build(LSH.TreeNum)# 30 trees
  INDEX = mat.or.vec(ncol(drData),k+1)
  for(i in seq(ncol(drData))){
      v = drData[,i]
      INDEX[i,] = Tree$getNNsByVector(v, k+1)
  }
  neigData <- t(INDEX)[-1,]
}

neigData <- neigData[-1,] 
colnames(neigData) <- colnames(drData)

## Solve for reconstruction weights
## Create matrix Z consisting of all neighbors of each cell
wgtsNR <- matrix(0, ncol(drData), ncol(drData))
rownames(wgtsNR) <- colnames(drData)
colnames(wgtsNR) <- colnames(drData)
k <- dim(neigData)[1]

for(i in seq_len(ncol(neigData))){
  
  # find neighbors of each cell
  neigZ <- drData[, neigData[,i]]
  
  # Calculate the differences between the cell and its neighbors
  diffZ <- neigZ - matrix(drData[,i,drop = FALSE],
                        nrow = nrow(drData),ncol = nrow(neigData),byrow = FALSE)
  localCova <- t(diffZ) %*% diffZ
  
  ## Solve linear system
  if(qr(localCova)$rank < nrow(localCova)){
    wgtsNRi <- pracma::pinv(localCova) %*% matrix(1,nrow=k,ncol=1)
  }else {
    wgtsNRi <- base::solve(localCova, matrix(1,nrow=k,ncol=1))
  }
  
  wgtsNRi <- t(wgtsNRi)
  wgtsNRiRegu <- wgtsNRi / sum(wgtsNRi)
  wgtsNR[i, rownames(localCova)] <- wgtsNRiRegu
 }
 NR <- wgtsNR
 
 return(NR)
}


#'
#' Estimate the optimal number of clusters C for clustering
#' 
#' @param drData gene expression matrix after PCA processing
#' @param S the calculated similarity matrix S from "SimS"
#'
#' @return C the estimated number of clusters
#'
#' @export
#'
#' @examples 
#' gfData <- GenesFilter(yan)
#' res_SimS <- SimS(gfData)
#' EstClusters(res_SimS$drData,res_SimS$S)
#'
"EstClusters" <- function(drData, S){ 

  Diss <- stats::as.dist(1 - S)
  
  if(nrow(S) > 3000){
      
      #set.seed(1)
      C <- NbClust::NbClust(t(drData), diss = Diss, distance = NULL,
                            min.nc = 4, max.nc = 12,
                            method = "average", index = "kl")$Best.nc[1]
  }else{ 
      Q0 <- - 10e11
      #set.seed(1)
      res <- NbClust::NbClust(t(drData), diss = Diss, distance = NULL,
                              min.nc = 4, max.nc = 12,
                              method = "average", index = "kl")$All.index
      res <- sort(res)
      l <- length(res)
      K_range <- as.numeric(attr(res, "names")[(l - 2):l])
      for(k in K_range){
         resBDSM <- BDSM(S, k)
         a <- resBDSM$y
         one <- matrix(c(seq_len(nrow(S))), byrow = TRUE)
         a <- as.matrix(cbind(one, a))
         b <- matrix(0,nrow = max(a),ncol = max(a))
         for(i in seq_len(nrow(a))){
             b[a[i,1], a[i,2]] <- 1
         }
         b <- b[, -(which(colSums(b) == 0)),drop = FALSE]
         m <- sum(S) / 2
         c <-  as.matrix(rowSums(S))
         B <- S - (kronecker(matrix(1,1,nrow(c)),c) * kronecker(matrix(1,nrow(c),1),t(c)))/(2 * m)
         Q1 <- 1/(2 * m) * sum(diag(t(b) %*% B %*% b))
         if(Q1 > Q0){
             Q0 <- Q1
             C <- k
           }
       }
     }
  return(C)
}

#' 
#' Solve the problem: min 1/2*x'*L*x-x'*d s.t. x>=0, 1'x=1
#' 
#' @param d matrix or vector
#' @param l matrix or vector
#' 
#' @return x 
"EProjSimplexdiag" <- function(d,l){
  lambda <- min(l - d)
  f <- 1
  count <- 1
  
  while(abs(f) > 10^-8){
    v1 <-  1 / l * lambda + d/l
    g <-  sum(1 / l[v1 > 0])
    f <-  sum(v1[v1 > 0]) - 1
    lambda <- lambda - f / g
    if(count > 1000){
    break}
    count <- count + 1
  }
  
  v1 = 1/l*lambda + d/l
  x <- pmax(v1,0)
  
  return(x)
}

#' 
#' Solve the problem: ||A-B||^2 = ||A||^2 + ||B||^2 - 2*A'*B
#' 
#' @param A matrix or vector
#' @param B matrix or vector
#' 
#' @return d matrix or vector
"EucDist" <- function(A, B){
  if (dim(A)[1] == 1){
    A <- rbind(A, matrix(0,1,dim(A)[2]))
    B <- rbind(B, matrix(0,1,dim(B)[2]))
  }
  
  aa <- t(as.matrix(colSums(A * A)))
  bb <- t(as.matrix(colSums(B * B)))
  ab <- t(A) %*% B
  
  d <- kronecker(matrix(1,1,dim(bb)[2]),t(aa)) + kronecker(matrix(1,dim(aa)[2],1), bb) - 2 * ab
  d <-  Re(d)
  d <-  pmax(d,0)
  
  return(d)
}

#' 
#' Calculate the bolock-diagnal matrix B
#' min_{B>=0, B*1=1, F'*F=I}  ||B - A||_1 + r*||B||^2 + 2*lambda*trace(F'*L*F)
#' 
#' @import igraph
#'
#' @param S the calculated initial similarity matrix S
#' @param C the estimated number of clusters C
#' 
#' @return B block-diagonal matrix
#' @return y clustering results
#'
#' @export
#'
#' @examples 
#' gfData <- GenesFilter(yan)
#' res_SimS <- SimS(gfData)
#' C <- EstClusters(res_SimS$drData,res_SimS$S)
#' BDSM(res_SimS$S,C)
#'
"BDSM" <- function(S, C){
  NITER <- 30
  zr  <-  10e-11
  lambda  <-  0.1
  r  <-  0

  S  <-  S - diag(diag(S))
  num <- nrow(S)
  A10 <-  (S + t(S)) / 2
  L0  <-  diag(colSums(A10)) - A10
  L0 <- pmax(L0, t(L0))
  tmp0 <- eigen(L0) 
  w0 <- tmp0$values
  V0 <- tmp0$vectors
  wsort0 <- sort(w0, index.return = TRUE)
  di0 <- wsort0$x
  idx0 <- wsort0$ix
  idx1 <- idx0[seq_len(num)]
  F  <-  V0[, idx1][, seq_len(C)]
 
  if(sum(w0[seq_len((C + 1))]) < zr){
     stop('The original graph has more than %d connected component', C)
   }
  
  if(sum(w0[seq_len(C)]) < zr){
     g0 <- igraph::graph_from_adjacency_matrix(A10)
     y <- as.matrix(components(g0, mode = "strong")$membership, drop = FALSE)
     B <-  S
     return
   }
    
  u = vector('list', num)  
  
  for(j in seq_len(num)){
     s0 <-  S[j,,drop = FALSE]
     idxa0 <- seq_len(num)
     u[[j]] <-  matrix(1, 1, length(idxa0))
  }
 
  for(iter in seq_len(NITER)){
      dist0 <- EucDist(t(F), t(F))
      B <-  matrix(0, num, num)
      for(i in seq_len(num)){
         idxa0 <-  seq_len(num)
         ai <-  S[i,,drop = FALSE][idxa0]
         di <-  dist0[i,idxa0,drop = F]
         ad <- u[[i]]*ai-lambda*di/2
         si <- EProjSimplexdiag(ad, u[[i]] + r * rep(1,length(idxa0)))
         u[[i]] <-  1 / (2 * sqrt((si - ai)^2 + .Machine$double.eps))
         B[i,idxa0] <-  si 
        }
      A <-  B
      A <-  (A + t(A)) / 2
      L <-  diag(colSums(A)) - A
      F_old <-  F
      L <-  pmax(L, t(L))
      w <-  eigen(L)$values
      V <-  eigen(L)$vectors
      wsort <-  sort(w,index.return = TRUE)
      idx2 <- wsort$ix[seq_len(C)]
      F <-  V[, idx2]
      ev <-  w[wsort$ix]
      fn1 <- sum(ev[seq_len(C)])
      fn2 <- sum(ev[seq_len(C+1)])
      if(fn1 > zr){ lambda <- 2 * lambda}
        else if(fn2 < zr) {
                   lambda <- lambda / 2 
                   F <- F_old
        }
       else {break}
   }
   cat("======== Calculate maximal strongly connected components ========","\n")
   g <- igraph::graph_from_adjacency_matrix(B,mode = "undirected",weighted = TRUE,diag = FALSE)
   G <- igraph::components(g, mode = "strong"); 
   y <- as.matrix(G$membership,drop = FALSE)
   clusternum <- G$no
   if(clusternum != C){
     sprintf('Can not find the correct cluster number: %d', C)
    }
   res <- list("B" = B, "y" = y)
   return(res)
}

#' A public scRNA-seq dataset by Yan et al.
#'
#' @source \url{http://dx.doi.org/10.1038/nsmb.2660}
#'
#' Columns represent cells, rows represent genes expression values.
#'
"yan"

#' Cell type annotations of `yan` datasets by Yan et al.
#'
#' @source \url{http://dx.doi.org/10.1038/nsmb.2660}
#'
#' Each row corresponds to one cell of `yan` dataset
#'
"ann"

   
   

library(RCSL)

library(SingleCellExperiment)
library(ggplot2)
library(igraph)

## Load dataset 
# For example, the input data is "Goolam.rds", but it could also be "Goolam.txt"

origData <- readRDS("./Data/Goolam.rds")
data <- logcounts(origData)
label <- origData$cell_type1
DataName <- "Goolam"

## Run RCSL
# RCSL in Detail
# The main `RCSL` method is a wrapper that calls other `RCSL` functions in the following order:
# GenesFilter(); SimS(); EstClusters(); BDSM()

res_RCSL <- RCSL(data, GF = TRUE, gfRatio = 0.025, pcRatio = 0.95, largeThre = 2000)



## Trajectory Analysis to time-series datasets
# TrajectoryAnalysis in Detail
# The main `TrajectoryAnalysis` method also calls other functions in the following order:
# PlotPseudoTime(); getLineage(); PlotMST(); PlotTrajectory()
# The MST plot can be displayed without the starting cell. 
# The pseudo-temporal ordering and the developmental trajectories need the starting cell as input.

res_TrajecAnalysis <- TrajectoryAnalysis(res_RCSL$gfData, res_RCSL$drData, res_RCSL$S,
                                         clustRes = res_RCSL$y, TrueLabel = label, startPoint = 1,
                                         dataName = DataName)
										 



# Display the constructed MST 

res_TrajecAnalysis$MSTPlot


# Display the plot of the pseudo-temporal ordering 

res_TrajecAnalysis$PseudoTimePlot


# Display the plot of the inferred developmental trajectory

res_TrajecAnalysis$TrajectoryPlot


# The clustering results can be evaluted by ARI

ARI_RCSL <- igraph::compare(res_RCSL$y, label, method = "adjusted.rand")

---
title: "A quick tour of RCSL"
author: "Qinglin Mei"
date: "`r Sys.Date()`"
output:
  BiocStyle::html_document:
    toc: true
    toc_depth: 2
vignette: >
  %\VignetteIndexEntry{RCSL package manual}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
  
```{r knitr-options, echo=FALSE, message=FALSE, warning=FALSE, include = FALSE}
knitr::opts_chunk$set(tidy = FALSE,
                      cache = FALSE,
                      dev = "png",
                      message = FALSE, error = FALSE, warning = TRUE)
```

# Introduction
`RCSL` is an R toolkit for single-cell clustering and trajectory analysis using single-cell RNA-seq data.

# Installation
### Install RCSL package and other requirements
`RCSL` can be installed directly from GitHub with 'devtools'.

```{r, eval=FALSE}
library(devtools)
devtools::install_github("QinglinMei/RCSL")
```

Now we can load `RCSL`. We also load the `SingleCellExperiment`, `ggplot2` and `igraph`  package.
```{r, results="hide"}
library(RCSL)
library(SingleCellExperiment)
library(ggplot2)
library(igraph)
library(umap)
```

# Run RCSL
## Load dataset (yan)
We illustrate the usage of RCSL on a human preimplantation embryos and embryonic stem cells(*Yan et al., (2013)*). The yan data is distributed together with the RCSL package, with 90 cells and 20,214 genes:
```{r}
data(yan, package = "RCSL")
head(ann)
yan[1:3, 1:3]
origData <- yan
label <- ann$cell_type1
```

## 1. Pre-processing
In practice, we find it always beneficial to pre-process single-cell RNA-seq datasets, including:
1. Log transformation.
2. Gene filter

```{r, cache=TRUE}
data <- log2(as.matrix(origData) + 1)
gfData <- GenesFilter(data)
```

## 2. Calculate the initial similarity matrix S
```{r, cache=TRUE}
resSimS <- SimS(gfData)
```

## 3. Estimate the number of clusters C
```{r, cache=TRUE}
Estimated_C <- EstClusters(resSimS$drData,resSimS$S)
```

## 4. Calculate the block diagonal matrix B
```{r, cache=TRUE}
resBDSM <- BDSM(resSimS$S, Estimated_C)
```

# Calculate accuracy of the clustering
```{r, cache=TRUE}
ARI_RCSL <- igraph::compare(resBDSM$y, label, method = "adjusted.rand")
```

# Trajectory analysis to time-series datasets
```{r, cache=TRUE}
DataName <- "Yan"
res_TrajecAnalysis <- TrajectoryAnalysis(gfData, resSimS$drData, resSimS$S,
                                         clustRes = resBDSM$y, TrueLabel = label, 
                                         startPoint = 1, dataName = DataName)
```										 

# Display the constructed MST 
```{r, cache=TRUE}
res_TrajecAnalysis$MSTPlot
```										 

# Display the plot of the pseudo-temporal ordering 
```{r, cache=TRUE}
res_TrajecAnalysis$PseudoTimePlot
```	

# Display the plot of the inferred developmental trajectory
```{r, cache=TRUE}
res_TrajecAnalysis$TrajectoryPlot
```	

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlotFunctions.R
\name{PlotMST}
\alias{PlotMST}
\title{Plot the visualization of constructed Minimum Spanning Tree based on the clustering results of RCSL}
\usage{
PlotMST(
  drData,
  clustRes,
  TrueLabel,
  dataName = "",
  fontSize = 12,
  VisualMethod = "umap"
)
}
\arguments{
\item{drData}{preprocessed gene expression data}

\item{clustRes}{the clustering results identified by RCSL}

\item{TrueLabel}{the real cell types to color the dots in plot}

\item{dataName}{the name of the data that will be showed in the plot}

\item{fontSize}{the font size of the plot}

\item{VisualMethod}{the method for 2D visualization including UMAP,t-SNE and PCA}
}
\value{
MSTPlot ggplot object of the visualization of constructed MST
}
\description{
Plot the visualization of constructed Minimum Spanning Tree based on the clustering results of RCSL
}
\examples{
gfData <- GenesFilter(yan)
TrueLabel <- ann$cell_type1
res_SimS <- SimS(gfData)
C <- EstClusters(res_SimS$drData,res_SimS$S)
res_BDSM <- BDSM(res_SimS$S,C)
PlotMST(res_SimS$drData,res_BDSM$y,TrueLabel)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlotFunctions.R
\name{PlotTrajectory}
\alias{PlotTrajectory}
\title{Infer the developmental trajectories based on the clustering results from RCSL}
\usage{
PlotTrajectory(
  gfData,
  clustRes,
  TrueLabel,
  lineage,
  fontSize = 12,
  dataName = "",
  VisualMethod = "umap"
)
}
\arguments{
\item{gfData}{preprocessed gene expression data (each column represent a cell)}

\item{clustRes}{the clustering results identified by RCSL}

\item{TrueLabel}{the real cell types}

\item{lineage}{the lineage obtained by getLineage()}

\item{fontSize}{the size of font in the plot}

\item{dataName}{the name of the data that will be showed in the plot}

\item{VisualMethod}{the display method of 2-D visualization}
}
\value{
TrajectoryPlot ggplot object of the inferred developmental trajectories
}
\description{
Infer the developmental trajectories based on the clustering results from RCSL
}
\examples{
gfData <- GenesFilter(yan)
TrueLabel <- ann$cell_type1
res_SimS <- SimS(gfData)
C <- EstClusters(res_SimS$drData,res_SimS$S)
res_BDSM <- BDSM(res_SimS$S,C)
Pseudo <- PlotPseudoTime(res_SimS$S,TrueLabel,startPoint=1)
Linea <- getLineage(res_SimS$drData,res_BDSM$y,Pseudo$pseudoTime)
PlotTrajectory(gfData,res_BDSM$y,TrueLabel,lineage=Linea)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlotFunctions.R
\name{TrajectoryAnalysis}
\alias{TrajectoryAnalysis}
\title{Trajectory analysis}
\usage{
TrajectoryAnalysis(
  gfData,
  drData,
  S,
  clustRes,
  fontSize = 12,
  TrueLabel,
  startPoint,
  dataName = "",
  sim = TRUE,
  simMeasure = "kendall",
  VisualMethod = "umap"
)
}
\arguments{
\item{gfData}{preprocessed gene expression data (each column represent a cell)}

\item{drData}{preprocessed gene expression data (each column represent a cell)}

\item{S}{the similarity matrix calculated by SimS() function}

\item{clustRes}{the clustering results identified by RCSL}

\item{fontSize}{the size of font in the plot}

\item{TrueLabel}{the real cell types used to indicate the vertical axis}

\item{startPoint}{the posiition of the starting cell in the matrix}

\item{dataName}{the name of the data that will be showed in the plot}

\item{sim}{indicate the input data is simialrity matrix or not}

\item{simMeasure}{the calculation method of measuring the cluster centers' similarity}

\item{VisualMethod}{the display method of 2-D visualization}
}
\value{
PseudoTimePlot, MSTPlot, TrajectoryPlot
}
\description{
Trajectory analysis
}
\examples{
gfData <- GenesFilter(yan)
TrueLabel <- ann$cell_type1
res_SimS <- SimS(gfData)
C <- EstClusters(res_SimS$drData,res_SimS$S)
res_BDSM <- BDSM(res_SimS$S,C)
TrajectoryAnalysis(gfData,res_SimS$drData,res_SimS$S,res_BDSM$y,
                   TrueLabel=TrueLabel,startPoint=1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RCSL.R
\name{RCSL}
\alias{RCSL}
\title{Perform the RCSL program}
\usage{
RCSL(
  data,
  GF = TRUE,
  gfRatio = 0.025,
  pcRatio = 0.95,
  NN.method = "KNN",
  Dis.method = "Euclidean",
  neiRatio = 0.65
)
}
\arguments{
\item{data}{normalizaed gene expression matrix(each column represents a cell)}

\item{GF}{should I need the gene filter step?}

\item{gfRatio}{the ratio of the gene filter}

\item{pcRatio}{the ratio between the variance of the}

\item{NN.method}{the method of finding neighbors}

\item{Dis.method}{the distance metric in finding neighbors}

\item{neiRatio}{ratio of the number of selected}
}
\value{
gfData gene expression matrix after genes filtering

B block-diagonal matrix

C estimated number of clusters

y clustering results
}
\description{
Perform the RCSL program
}
\examples{
data(yan)
data <- log2(yan+1)
RCSL(yan[,1:20])
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MainFunctions.R
\name{EstClusters}
\alias{EstClusters}
\title{Estimate the optimal number of clusters C for clustering}
\usage{
EstClusters(drData, S)
}
\arguments{
\item{drData}{gene expression matrix after PCA processing}

\item{S}{the calculated similarity matrix S from "SimS"}
}
\value{
C the estimated number of clusters
}
\description{
Estimate the optimal number of clusters C for clustering
}
\examples{
gfData <- GenesFilter(yan)
res_SimS <- SimS(gfData)
EstClusters(res_SimS$drData,res_SimS$S)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlotFunctions.R
\name{getLineage}
\alias{getLineage}
\title{Infer the development lineage based on the clustering results from RCSL and the pseudotime}
\usage{
getLineage(drData, clustRes, pseudoTime, simMeasure = "kendall")
}
\arguments{
\item{drData}{preprocessed gene expression data (each column represent a cell)}

\item{clustRes}{the clustering results identified by RCSL}

\item{pseudoTime}{inferred by PlotPseudoTime() using the similarity matrix S and starting cell}

\item{simMeasure}{the calculation method of measuring the cluster centers' similarity}
}
\value{
lineage the cell lineages connected all the cluster centers based on the clustering results from RCSL
}
\description{
Infer the development lineage based on the clustering results from RCSL and the pseudotime
}
\examples{
gfData <- GenesFilter(yan)
TrueLabel <- ann$cell_type1
res_SimS <- SimS(gfData)
C <- EstClusters(res_SimS$drData,res_SimS$S)
res_BDSM <- BDSM(res_SimS$S,C)
Pseudo <- PlotPseudoTime(res_SimS$S,TrueLabel,startPoint=1)
getLineage(res_SimS$drData,res_BDSM$y,Pseudo$pseudoTime)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MainFunctions.R
\name{GenesFilter}
\alias{GenesFilter}
\title{Perform the step of gene filtering to normalizaed gene expression data}
\usage{
GenesFilter(data, gfRatio = 0.025)
}
\arguments{
\item{data}{the normalized gene expression matrix}

\item{gfRatio}{the ratio of genes filtering}
}
\value{
the gene expression matrix after genes filtering gfData
}
\description{
Perform the step of gene filtering to normalizaed gene expression data
}
\examples{
data(yan)
GenesFilter(yan)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MainFunctions.R
\name{NeigRepresent}
\alias{NeigRepresent}
\title{Calculate the neighbor representation of cells to the low-dimensional 
gene expression matrix}
\usage{
NeigRepresent(
  drData,
  NN.method = "KNN",
  Dis.method = "Euclidean",
  LSH.TreeNum = 30,
  LSH.Dim = 500,
  LSH.Dis = "angular",
  neiRatio = 0.65
)
}
\arguments{
\item{drData}{gene expression matrix after dimensionality reduced by PCA}

\item{NN.method}{the method of finding neighbors}

\item{Dis.method}{the distance metric in finding neighbors}

\item{LSH.TreeNum}{the tree number of LSH}

\item{LSH.Dim}{the dimension in LSH}

\item{LSH.Dis}{the distance metric in LSH}

\item{neiRatio}{ratio of the number of selected}
}
\value{
the similarity matrix measured by neighbor representation NR
}
\description{
Calculate the neighbor representation of cells to the low-dimensional 
gene expression matrix
}
\examples{
gfData <- GenesFilter(yan)
res_SimS <- SimS(gfData)
NeigRepresent(res_SimS$drData)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MainFunctions.R
\name{EucDist}
\alias{EucDist}
\title{Solve the problem: ||A-B||^2 = ||A||^2 + ||B||^2 - 2*A'*B}
\usage{
EucDist(A, B)
}
\arguments{
\item{A}{matrix or vector}

\item{B}{matrix or vector}
}
\value{
d matrix or vector
}
\description{
Solve the problem: ||A-B||^2 = ||A||^2 + ||B||^2 - 2*A'*B
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MainFunctions.R
\name{EProjSimplexdiag}
\alias{EProjSimplexdiag}
\title{Solve the problem: min 1/2*x'*L*x-x'*d s.t. x>=0, 1'x=1}
\usage{
EProjSimplexdiag(d, l)
}
\arguments{
\item{d}{matrix or vector}

\item{l}{matrix or vector}
}
\value{
x
}
\description{
Solve the problem: min 1/2*x'*L*x-x'*d s.t. x>=0, 1'x=1
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MainFunctions.R
\name{SimS}
\alias{SimS}
\title{Calculate the initial similarity matrix}
\usage{
SimS(
  data,
  pcRatio = 0.95,
  gamma = 0.8,
  NN.method = "KNN",
  Dis.method = "Euclidean",
  LSH.TreeNum = 30,
  LSH.Dim = 1000,
  LSH.Dis = "angular",
  neiRatio = 0.65
)
}
\arguments{
\item{data}{gene expression matrix after genes filtering}

\item{pcRatio}{the ratio between the variance of the}

\item{gamma}{the ratio of the global simialrity}

\item{NN.method}{the method of finding neighbors}

\item{Dis.method}{the distance metric in finding neighbors}

\item{LSH.TreeNum}{the tree number of LSH}

\item{LSH.Dim}{the dimension in LSH}

\item{LSH.Dis}{the distance metric in LSH}

\item{neiRatio}{ratio of the number of selected}
}
\value{
initial similarity matrix S

gene expression matrix after PCA processing drData
}
\description{
Calculate the initial similarity matrix
}
\examples{
gfData <- GenesFilter(yan)
SimS(gfData)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlotFunctions.R
\name{PlotPseudoTime}
\alias{PlotPseudoTime}
\title{Infer the pseudo-temporal ordering between the cell types using the
distance from a cell type to the predefined starting cell type.}
\usage{
PlotPseudoTime(
  S,
  TrueLabel,
  startPoint,
  fontSize = 12,
  dataName = "",
  sim = TRUE
)
}
\arguments{
\item{S}{the similarity matrix calculated by SimS() function}

\item{TrueLabel}{the real cell types used to indicate the vertical axis}

\item{startPoint}{the posiition of the starting cell in the matrix}

\item{fontSize}{the font size of the plot}

\item{dataName}{the name of the data that will be showed in the plot}

\item{sim}{indicate the input data is simialrity matrix or not}
}
\value{
PstudoTime

PseudoTimePlot  ggplot object of the pseudo-temporal ordering of cells
}
\description{
Infer the pseudo-temporal ordering between the cell types using the
distance from a cell type to the predefined starting cell type.
}
\examples{
gfData <- GenesFilter(yan)
TrueLabel <- ann$cell_type1
res_SimS <- SimS(gfData)
PlotPseudoTime(res_SimS$S,TrueLabel,startPoint=1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MainFunctions.R
\docType{data}
\name{ann}
\alias{ann}
\title{Cell type annotations of `yan` datasets by Yan et al.}
\format{
An object of class \code{data.frame} with 90 rows and 1 columns.
}
\source{
\url{http://dx.doi.org/10.1038/nsmb.2660}

Each row corresponds to one cell of `yan` dataset
}
\usage{
ann
}
\description{
Cell type annotations of `yan` datasets by Yan et al.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MainFunctions.R
\docType{data}
\name{yan}
\alias{yan}
\title{A public scRNA-seq dataset by Yan et al.}
\format{
An object of class \code{data.frame} with 20214 rows and 90 columns.
}
\source{
\url{http://dx.doi.org/10.1038/nsmb.2660}

Columns represent cells, rows represent genes expression values.
}
\usage{
yan
}
\description{
A public scRNA-seq dataset by Yan et al.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MainFunctions.R
\name{BDSM}
\alias{BDSM}
\title{Calculate the bolock-diagnal matrix B
min_{B>=0, B*1=1, F'*F=I}  ||B - A||_1 + r*||B||^2 + 2*lambda*trace(F'*L*F)}
\usage{
BDSM(S, C)
}
\arguments{
\item{S}{the calculated initial similarity matrix S}

\item{C}{the estimated number of clusters C}
}
\value{
B block-diagonal matrix

y clustering results
}
\description{
Calculate the bolock-diagnal matrix B
min_{B>=0, B*1=1, F'*F=I}  ||B - A||_1 + r*||B||^2 + 2*lambda*trace(F'*L*F)
}
\examples{
gfData <- GenesFilter(yan)
res_SimS <- SimS(gfData)
C <- EstClusters(res_SimS$drData,res_SimS$S)
BDSM(res_SimS$S,C)

}
